// vc5Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "vc5.h"
#include "vc5Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVc5Dlg dialog

CVc5Dlg::CVc5Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVc5Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVc5Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	start=0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(logname,0x00,sizeof(logname));
	memset(lognameB,0x00,sizeof(lognameB));
	memset(serconfig,0x00,sizeof(serconfig));
	memset(serconfig2,0x00,sizeof(serconfig2));
	memset(serconfigB,0x00,sizeof(serconfigB));
	memset(serconfig2B,0x00,sizeof(serconfig2B));
	memset(ATRMsg,0x00,sizeof(ATRMsg));
	ATRMsg[0]=0x90;
	ATRSize=2;
	logfile=NULL;
	u_reply[0]=0x90;
	u_reply[1]=0x00;
}

void CVc5Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVc5Dlg)
	DDX_Control(pDX, IDC_CHECK4, m_tweak);
	DDX_Control(pDX, IDC_CHECK3, m_hold);
	DDX_Control(pDX, IDC_CHECK2, m_bin);
	DDX_Control(pDX, IDC_LIST1, m_log);
	DDX_Control(pDX, IDC_LIST2, m_commands);
	DDX_Control(pDX, IDC_CHECK1, m_check);
	DDX_Control(pDX, IDC_EDIT3, m_serconfig);
	DDX_Control(pDX, IDC_EDIT2, m_serconfig2);
	DDX_Control(pDX, IDC_EDIT1, msg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVc5Dlg, CDialog)
	//{{AFX_MSG_MAP(CVc5Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_DESTROY()
	ON_EN_KILLFOCUS(IDC_EDIT2, OnKillfocusEdit2)
	ON_EN_KILLFOCUS(IDC_EDIT3, OnKillfocusEdit3)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_STATIC, OnBitmap)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVc5Dlg message handlers

BOOL CVc5Dlg::OnInitDialog()
{
	char	string[256];
	
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// create events
	stopEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	resetEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	readEvent = CreateEvent(NULL,TRUE,FALSE,NULL);

	DWORD threadid;
	//start de thread
	thread=CreateThread(NULL,NULL,LogThread,(void*)this,0,&threadid);

	// TODO: Add extra initialization here
	m_commands.InsertString(0,"New Command");
	m_commands.SetCurSel(0);
	msg.SetWindowText("0");
	counter=0;

	scbase = new CSCBase(resetEvent,readEvent);
	
	strcpy(lastlist,AfxGetApp()->GetProfileString("config","list","NULL"));
	if (strcmp(lastlist,"NULL")!=0)
	{
		if (!LoadList(lastlist))
		{
			OnButton4();	// new list
		}
	}
	else
	{
		OnButton4();	// new list
	}	
	sprintf(string,"MacSmart [%s]",logname);
	SetWindowText(string);
	if (m_bin.GetCheck()==0)
		logfile=fopen(logname,"w+t");
	else
		logfile=fopen(logname,"w+b");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVc5Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVc5Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVc5Dlg::OnButton1() // ReStart
{
	char	string[256];
	
	while (m_log.DeleteString(0)!=LB_ERR);
	
	if (logfile)
		fclose(logfile);
	if (m_bin.GetCheck()==0)
		logfile=fopen(logname,"w+t");
	else
		logfile=fopen(logname,"w+b");

	scbase->Close();
	scbase->Open(serconfig);
	m_log.AddString("Ready...");
	scbase->SetConfig(serconfig2);
	counter=0;
	sprintf(string,"%lu",counter);
	msg.SetWindowText(string);
	scbase->Flush();
}

void CVc5Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	AfxGetApp()->WriteProfileString("config","list",lastlist);

	SetEvent(stopEvent);
	WaitForSingleObject(thread,INFINITE);
	delete scbase;
	CloseHandle(stopEvent);
	CloseHandle(resetEvent);
	CloseHandle(readEvent);
}


void CVc5Dlg::OnKillfocusEdit2() 
{
	// TODO: Add your control notification handler code here
	m_serconfig2.GetWindowText(serconfig2,sizeof(serconfig2));
}

void CVc5Dlg::OnKillfocusEdit3() 
{
	// TODO: Add your control notification handler code here
	m_serconfig.GetWindowText(serconfig,sizeof(serconfig));
	scbase->SetConfig(serconfig);
}

void CVc5Dlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	invert=m_check.GetCheck();
	scbase->SetInvert(invert);
}
int CVc5Dlg::LoadList(const char *fn)
{
	FILE*	fin;
	int		cnt,i,bin_text;
	CCommand	*com;
	char	string[256];

	fin=fopen(fn,"rb");
	if (fin==NULL)
		return 0;
	CleanupList();
	// first strings
	fread(lognameB,sizeof(lognameB),1,fin);
	fread(logname,sizeof(logname),1,fin);
	fread(serconfigB,sizeof(serconfigB),1,fin);
	fread(serconfig,sizeof(serconfig),1,fin);
	fread(serconfig2B,sizeof(serconfig2B),1,fin);
	fread(serconfig2,sizeof(serconfig2),1,fin);
	fread(&ATRSize,sizeof(DWORD),1,fin);
	fread(ATRMsg,64,1,fin);
	fseek(fin,256,SEEK_CUR);//reserved!
	fread(&bin_text,sizeof(int),1,fin);
	m_bin.SetCheck(bin_text);
	fread(&invert,sizeof(int),1,fin);

	scbase->SetInvert(invert);
	scbase->SetConfig(serconfig);
	m_check.SetCheck(invert);
	
	sprintf(string,"MacSmart [%s]",logname);
	SetWindowText(string);
	m_serconfig.SetWindowText(serconfig);
	m_serconfig2.SetWindowText(serconfig2);

	fread(&cnt,sizeof(cnt),1,fin);
	for(i=0;i<cnt;i++)
	{
		com=new CCommand();
		fread(com,sizeof(CCommand),1,fin);
		commands.AddTail(com);
		sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",com->id,
				com->com[0],com->com[1],com->com[2],com->com[3],com->com[4]);
		m_commands.AddString(string);
	}
	fclose(fin);
	return 1;
}
int CVc5Dlg::SaveList(const char *fn)
{
	FILE*	fin;
	int		cnt,i,bin_text;
	CCommand	*com;
	POSITION	pos;

	fin=fopen(fn,"w+b");
	if (fin==NULL)
	{	
		AfxMessageBox("Could not save",MB_OK);
		return 0;
	}

	fwrite(lognameB,sizeof(lognameB),1,fin);
	fwrite(logname,sizeof(logname),1,fin);
	fwrite(serconfigB,sizeof(serconfigB),1,fin);
	fwrite(serconfig,sizeof(serconfig),1,fin);
	fwrite(serconfig2B,sizeof(serconfig2B),1,fin);
	fwrite(serconfig2,sizeof(serconfig2),1,fin);
	fwrite(&ATRSize,sizeof(DWORD),1,fin);
	fwrite(ATRMsg,64,1,fin);
	fwrite(serconfig2B,sizeof(serconfig2B),1,fin);	//reserved
	fwrite(serconfig2B,sizeof(serconfig2B),1,fin);
	bin_text=m_bin.GetCheck();
	fwrite(&bin_text,sizeof(int),1,fin);
	fwrite(&invert,sizeof(int),1,fin);

	cnt=commands.GetCount();
	fwrite(&cnt,sizeof(int),1,fin);
	pos=commands.GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		fwrite(com,sizeof(CCommand),1,fin);
	}
	fclose(fin);
	return 1;
}
void CVc5Dlg::CleanupList()
{
	int			i,cnt;
	CCommand	*com;
	POSITION	pos;
	DWORD		tt;
	
	cnt=commands.GetCount();
	pos=commands.GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		tt=m_commands.DeleteString(1);
		delete com;
	}
	commands.RemoveAll();
}

void CVc5Dlg::OnButton2() // Load CommandList
{
	CFileDialog	dlg(TRUE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"SmartCard Configuration files (*.scc) | *.scc|All Files (*.*)|*.*||");
	char	string[256];

	strcpy(string,lastlist);
	dlg.m_ofn.lpstrFile=string;

	if (dlg.DoModal()==IDOK)
	{
		if (LoadList(dlg.GetPathName()))
		{
			strcpy(lastlist,dlg.GetPathName());
		}
	}
}

void CVc5Dlg::OnButton3() // Save CommandList
{
	CFileDialog	dlg(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"SmartCard Configuration files (*.scc) | *.scc|All Files (*.*)|*.*||");
	char	string[256];

	strcpy(string,lastlist);
	dlg.m_ofn.lpstrFile=string;
	dlg.m_ofn.lpstrDefExt="scc";
	if (dlg.DoModal()==IDOK)
	{
		if (SaveList(dlg.GetPathName()))
		{
			strcpy(lastlist,dlg.GetPathName());
		}
	}
}

void CVc5Dlg::OnButton4() // New CommandList
{
	char	string[256];

	CleanupList();
	strcpy(logname,"test2.txt");
	strcpy(lognameB,"test.txt");
	strcpy(serconfig,"COM2: baud=10472 parity=E data=8 stop=2");
	strcpy(serconfig2,"COM2: baud=10472 parity=E data=8 stop=2");
	strcpy(serconfigB,"COM2: baud=9600 parity=E data=8 stop=2");
	strcpy(serconfig2B,"COM2: baud=9600 parity=E data=8 stop=2");
	invert=0;
	scbase->SetInvert(invert);
	scbase->SetConfig(serconfig);
	m_check.SetCheck(invert);
	sprintf(string,"MacSmart [%s]",logname);
	SetWindowText(string);
	m_serconfig.SetWindowText(serconfig);
	m_serconfig2.SetWindowText(serconfig2);
	strcpy(lastlist,"noname.scc");
}
void CVc5Dlg::OnButton5() // Edit Command
{
	CNewCommandDlg	dlg(this);	
	char		string[256];
	int			res,sel;
	POSITION	pos;
	CCommand	com;
	
	if (m_commands.GetCurSel()<0)
		return;
	if (m_commands.GetCurSel()==0)
	{
		dlg.com = new CCommand();
	}
	else
	{
		pos=commands.FindIndex(m_commands.GetCurSel()-1);
		com=(*commands.GetAt(pos));
		dlg.com = &com;
	}
	if ((res=dlg.DoModal())==IDOK)
	{
		if (m_commands.GetCurSel()==0)
		{
			commands.AddTail(dlg.com);
			sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",dlg.com->id,
				dlg.com->com[0],dlg.com->com[1],dlg.com->com[2],dlg.com->com[3],dlg.com->com[4]);
			m_commands.AddString(string);
		}
		else
		{
			pos=commands.FindIndex(m_commands.GetCurSel()-1);
			(*commands.GetAt(pos))=com;

			sprintf(string,"%s (%02hX %02hX %02hX %02hX %02hX)",dlg.com->id,
				dlg.com->com[0],dlg.com->com[1],dlg.com->com[2],dlg.com->com[3],dlg.com->com[4]);
			m_commands.InsertString(m_commands.GetCurSel(),string);
			m_commands.DeleteString(sel=m_commands.GetCurSel());
			m_commands.SetCaretIndex(sel-1,FALSE);
		}
	}
	else if (res==IDABORT)
	{
		if (m_commands.GetCurSel()>0)
		{
			pos=commands.FindIndex(m_commands.GetCurSel()-1);
			commands.RemoveAt(pos);
			m_commands.DeleteString(m_commands.GetCurSel());
			m_commands.SetCurSel(0);
		}
	}
}
void CVc5Dlg::OnBitmap()
{
	CAboutDlg	dlg(this);

	dlg.DoModal();
}
DWORD CVc5Dlg::LogThread(LPVOID p)
{
	CVc5Dlg*	dlg = (CVc5Dlg*)p;
	HANDLE		wevents[3] = {NULL,NULL,NULL};
	char		string[256];
	char		string2[25];
	DWORD		bytes,wobject,bb,cnt;
	BYTE		buf[256];
	CCommand	*com;

	wevents[0]=dlg->stopEvent;
	wevents[1]=dlg->resetEvent;
	wevents[2]=dlg->readEvent;
	while (TRUE)
	{
		wobject=WaitForMultipleObjects(3,wevents,FALSE,INFINITE);
		if (wobject==WAIT_FAILED)
			wobject=wobject;
		switch (wobject)
		{
		case WAIT_OBJECT_0:		// stopEvent
			return 0;
			break;
		case WAIT_OBJECT_0+1:	// resetEvent
				dlg->m_log.AddString("RESET");
				if (dlg->m_hold.GetCheck())
				{
					ResetEvent(wevents[1]);
					break;
				}
				dlg->scbase->Write(dlg->ATRMsg,dlg->ATRSize);
				if (dlg->m_tweak.GetCheck()==0)
				{
					cnt=0;
					bytes=1;
					while (cnt<64 && bytes!=0)
					{
						bytes=dlg->scbase->Read(&buf[cnt],1,1);
						if (buf[cnt]==0x90)
							break;
						cnt++;
					}
					if (cnt>=64 || bytes==0)
						dlg->m_log.AddString("Error sending ATR");
					bytes=dlg->scbase->Read(&buf[++cnt],1,1);
					if (buf[cnt]!=0x00)
						dlg->m_log.AddString("Error sending ATR");
					dlg->Dump(buf,cnt+1);
				}

				//dlg->scbase->SetConfig(dlg->serconfig);
				ResetEvent(wevents[1]);
			break;
		case WAIT_OBJECT_0+2:	// readEvent
			ResetEvent(wevents[2]);
			if (dlg->m_hold.GetCheck())
			{
				bytes=dlg->scbase->Read(buf,64,2);
				dlg->Dump2(buf,bytes);
				break;
			}
			bytes=dlg->scbase->Read(buf,5,2);
			if (bytes==0)
				break;
			if (bytes<5)
			{
				dlg->m_log.AddString("Error on receive");
				dlg->m_log.SetCaretIndex(dlg->m_log.GetCount()-1,FALSE);
				break;
			}
			com=dlg->FindCommand(buf);
			if (com==NULL)
			{
				dlg->m_log.AddString("Unknown command:");
				dlg->scbase->Write(dlg->u_reply,2);
				if (dlg->m_tweak.GetCheck()==0)
					bytes+=dlg->scbase->Read(buf+bytes,2,4);
			}
			else
			{
				dlg->scbase->Write(&com->com[1],1);
				if (com->dir==1)
				{
					if (dlg->m_tweak.GetCheck()==0)
					{
						bb=dlg->scbase->Read(buf+bytes,com->com[4]+1,10);
						if (bb<com->com[4]+1)
							dlg->m_log.AddString("Error on receive (length)");
						bytes+=bb;
					}
					else
					{
						bb=dlg->scbase->Read(buf+bytes,com->com[4],10);
						if (bb<com->com[4])
							dlg->m_log.AddString("Error on receive (length)");
						bytes+=bb;
					}
				}
				else
				{
					dlg->scbase->Write(com->msg2,com->com[4]);	
					if (dlg->m_tweak.GetCheck()==0)
					{
						bb=dlg->scbase->Read(buf+bytes,com->com[4]+1,10);
						if (bb<com->com[4]+1)
							dlg->m_log.AddString("Error on receive (length2)");
						bytes+=bb;
					}
				}
				dlg->scbase->Write(com->reply,2);
				if (dlg->m_tweak.GetCheck()==0)
					bytes+=dlg->scbase->Read(buf+bytes,2,4);
			}
			dlg->Dump(buf,bytes);
			break;
		}
	}
	return 0;
}

void CVc5Dlg::OnButton6() // Set ATR
{
	// TODO: Add your control notification handler code here
	BYTE	buf[sizeof(ATRMsg)];
	CATRDlg	dlg(this);
	
	memcpy(buf,ATRMsg,sizeof(ATRMsg));
	dlg.ATRMsg=buf;
	dlg.ATRSize=ATRSize;
	if (dlg.DoModal()==IDOK)
	{
		memcpy(ATRMsg,dlg.ATRMsg,sizeof(ATRMsg));
		ATRSize=dlg.ATRSize;
	}
}
CCommand*	CVc5Dlg::FindCommand(BYTE *command)
{
	int			cnt,i;
	POSITION	pos;
	CCommand	*com;
	
	cnt=commands.GetCount();
	pos=commands.GetHeadPosition();
	for(i=0;i<cnt;i++)
	{
		com=commands.GetNext(pos);
		if (memcmp(command,com->com,5)==0)
			return com;
	}
	return NULL;
}

void CVc5Dlg::Dump(BYTE *buf,int bytes)
{
	char		string[256];
	char		string2[25];
	DWORD		i,j,cnt;

	if (m_bin.GetCheck()==1 && logfile!=NULL)
	{
		fwrite(&buf,1,bytes,logfile);
	}
	counter+=bytes;
	sprintf(string,"%lu",counter);
	msg.SetWindowText(string);
	cnt=0;
	while (bytes>0)
	{
		if (bytes>=16)
			j=16;
		else
			j=bytes;
		bytes-=j;
		string[0]=0x00;
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",buf[cnt]);
			cnt++;
			strcat(string,string2);
		}
		m_log.AddString(string);
		if (m_bin.GetCheck()==0 && logfile!=NULL)
		{
			fprintf(logfile,"%s\n",string);
		}
	}
	m_log.SetCaretIndex(m_log.GetCount()-1,FALSE);
}
void CVc5Dlg::Dump2(BYTE *buf,int bytes)
{
	char		string[256];
	char		string2[25];
	DWORD		i,j,cnt;

	if (m_bin.GetCheck()==1 && logfile!=NULL)
	{
		fwrite(&buf,1,bytes,logfile);
	}
	counter+=bytes;
	sprintf(string,"%lu",counter);
	msg.SetWindowText(string);
	cnt=0;
	while (bytes>0)
	{
		if (bytes>=16)
			j=16;
		else
			j=bytes;
		bytes-=j;
		strcpy(string,"[");
		for(i=0;i<j;i++)
		{
			sprintf(string2,"%02hX ",buf[cnt]);
			cnt++;
			strcat(string,string2);
		}
		strcat(string,"]");
		m_log.AddString(string);
		if (m_bin.GetCheck()==0 && logfile!=NULL)
		{
			fprintf(logfile,"%s\n",string);
		}
	}
	m_log.SetCaretIndex(m_log.GetCount()-1,FALSE);
}

void CVc5Dlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	CFileDialog	*dlg;
	char	string[256];

	if (m_bin.GetCheck()==1)
	{
		dlg= new CFileDialog(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"log files (*.bin) | *.bin|All Files (*.*)|*.*||");
		dlg->m_ofn.lpstrDefExt="bin";
	}
	else
	{
		dlg= new CFileDialog(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"log files (*.txt) | *.txt|All Files (*.*)|*.*||");
		dlg->m_ofn.lpstrDefExt="txt";
	}
	
	strcpy(string,logname);
	dlg->m_ofn.lpstrFile=string;
	
	if (dlg->DoModal()==IDOK)
	{
		strcpy(logname,dlg->GetPathName());
		sprintf(string,"MacSmart [%s]",logname);
		SetWindowText(string);
		m_log.AddString("Click (Re)Start for new settings to take effect!");
		m_log.SetCaretIndex(m_log.GetCount()-1,FALSE);
	}
	delete dlg;
}
void CVc5Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

